# example A.8 of section A.2.2 
# (example A.8 of section A.2.2)  : Starting with R and other tools : Starting with R : Primary R data types 
# Title: Confirm lm() encodes new strings correctly 

d <- data.frame(x=factor(c('a','b','c')),
                   y=c(1,2,3))
m <- lm(y~0+x,data=d)                             	# Note: 1 
print(predict(m,
   newdata=data.frame(x='b'))[[1]])               	# Note: 2 
# [1] 2
print(predict(m,
   newdata=data.frame(x=factor('b',levels=c('b'))))[[1]])        	# Note: 3 
# [1] 2

# Note 1: 
#   Build a data frame and linear model mapping 
#   a,b,c to 1,2,3. 

# Note 2: 
#   Show that model gets correct prediction for 
#   b as a string. 

# Note 3: 
#   Show that model gets correct prediction for 
#   b as a factor, encoded with a different number of 
#   levels. This shows that lm() is correctly treating 
#   factors as strings. 

